// Author: Torsten.Leitner@email.de
// (c) 2006/2007


#include "fftw_fft.h"

/*
fftw_fft::fftw_fft()
{
}

fftw_fft::~fftw_fft()
{
}
*/

using namespace std;
// /*
 fftw_fft1d::fftw_fft1d()
{
//	fftw_fft1d(10);
//	cout << "Variable of Type \"fftw_fft1d\" constructed ...   at "<< this << endl;
}
 // */
 
// /*
fftw_fft1d::fftw_fft1d(int inN)
{
	init(inN);
//	cout << "Variable of Type \"fftw_fft1d\" constructed and initialized ...  at "<< this << endl;
}
// */

// *********************************************************************************** //

fftw_fft1d::~fftw_fft1d()
{	
	
	fftw_destroy_plan(forward );
	fftw_destroy_plan(backward);
	fftw_free(in);
	fftw_free(out);
//	cout << "Variable of Type \"fftw_fft1d\" destructed ..."<< endl;
}




///// FFT !!!!!	  start		--- alles in eine klasse-packen ...
//						    fft.init(Ntw);     + fft.change_size(Ntw)  + fft.optimize_dimension(Ntw) ...
//						    fft.trans_for_back_inv(&Daten ... &Laser ... &field2d ... etc);
//						--- Es bleiben   wavetable, workspace und fftw_fft_data die ganze zeit erhalten ...
//							flag, das anzeigt ob schon initialisiert bzw. alloziert wurde ...
//						--- Ausgabe Option für Sortierte Reihenfolge ... Speicherung in dft-style wegen ruecktrafo ...
//
// 	objekt evtl static bzw global erstellen ... nur 1 workspace benoetigt ???
//
//	kontra:  Fund braucht kleineren W_Space als Pnl , auch Harm_braucht eigenen w_space 
//
//	==>  
//   Fuege ueber Def. const fuer maxPrime ein ... 
//   Primberichtigung als Option von feld, das dann objekt FFT als privates objekt enthaelt ...
//       Ubergabe der primflags duzrch feld regeln in fft bearbeiten ...
//   Weglassen !!!
// **************************************************************************************************'
// **************************************************************************************************'
// **************************************************************************************************'
// /*
	
int fftw_fft1d::init(int inN)
{	
	N=inN;
	in  = (fftw_complex*) fftw_malloc( sizeof(fftw_complex) * N );
	out = (fftw_complex*) fftw_malloc( sizeof(fftw_complex) * N );
	forward  = fftw_plan_dft_1d( N, in, out, FFTW_FORWARD,  FFTW_ESTIMATE );
	backward = fftw_plan_dft_1d( N, in, out, FFTW_BACKWARD, FFTW_ESTIMATE );
	return 0;
}
// **************************************************************************************************'	


// Do the transformation ...	
// **************************************************************************************************'
// **************************************************************************************************'
int fftw_fft1d::fft(Complex *d)
{
	for(j=0;j<N;j++){ in[j][0] = d[j].real() ; in[j][1] = d[j].imag();  } 

//	 Foo * fooPtr = new Foo( 2, 3 ) ;  // create a Foo pointer
// 	 Bar * barPtr = reinterpret_cast<Bar *>( fooPtr ) ;
//	 reinterpret_cast<<type>>( <val> );
//	in = reinterpret_cast<fftw_complex *>( d );
	
	//in=d;
	
	
	fftw_execute( forward ); //cout << " fft:forward ... " << endl;
	
	//d=out;
	for(j=0;j<N;j++){ d[j] = Complex ( out[j][0] , out[j][1] );}
	
//	d = reinterpret_cast<Complex *>( out );
	
	return 0;
}
// **************************************************************************************************'
int fftw_fft1d::fft(vector<Complex > *d)
{
	for(j=0;j<N;j++){ in[j][0] = d->at(j).real() ; in[j][1] = d->at(j).imag();  } 
	//in=d;
	
	fftw_execute( forward );// cout << " fft:forward ... " << endl;
	
	//d=out;
	for(j=0;j<N;j++){ d->at(j) = Complex ( out[j][0] , out[j][1] );}
	return 0;
}
// **************************************************************************************************'

// **************************************************************************************************'
int fftw_fft1d::bfft(Complex *d)
{
	for(j=0;j<N;j++){ in[j][0] = d[j].real() ; in[j][1] = d[j].imag();  } 
	
	fftw_execute( backward ); //cout << " fft:backward ..." << endl;
	
	for(j=0;j<N;j++){ d[j] = Complex ( out[j][0] , out[j][1] );}
	return 0;
}
// **************************************************************************************************'
int fftw_fft1d::bfft(vector<Complex > *d)
{
	for(j=0;j<N;j++){ in[j][0] = d->at(j).real() ; in[j][1] = d->at(j).imag();  } 
	
	fftw_execute( backward ); //cout << " fft:backward ..." << endl;
	
	for(j=0;j<N;j++)	{ d->at(j) = Complex ( out[j][0] , out[j][1] );}
	return 0;
}
// **************************************************************************************************'
int fftw_fft1d::ifft(Complex *d)
{
	for(j=0;j<N;j++){ in[j][0] = d[j].real() ; in[j][1] = d[j].imag();  } 
	
	fftw_execute( backward );  //cout << " fft:inverse , normalized ..." << endl;
	
	for(j=0;j<N;j++){ d[j] = Complex ( out[j][0] , out[j][1] );
					  d[j]/= N;		}
	return 0;
}
// **************************************************************************************************'
int fftw_fft1d::ifft(vector<Complex > *d)
{
	for(j=0;j<N;j++){ in[j][0] = d->at(j).real() ; in[j][1] = d->at(j).imag();  } 
	
	fftw_execute( backward );  //cout << " fft:inverse , normalized ..." << endl;
	
	for(j=0;j<N;j++){ d->at(j) = Complex ( out[j][0] , out[j][1] );
					  d->at(j)/= N;		}	
	return 0;
}
// **************************************************************************************************'

// **************************************************************************************************'
// **************************************************************************************************'
// **************************************************************************************************'



///// FFT !!!!!	  end
// **************************************************************************************************' 
// **************************************************************************************************'
// **************************************************************************************************'
 








